/*
 * Copy me if you can.
 * by 20h
 */

#include <u.h>
#include <libc.h>
#include "xmlpull.h"
#include "jacc.h"
#include "dat.h"
#include "roster.h"

int doignore;

int
recvjacc(int sock, jabberc *me, char *pass)
{
	xmlpull *x, *b;
	char *id, *to, *from, *tmstmp, st, *type, *va, *xm;
	rostern *ac, *p;

	type = nil;
	id = nil;
	from = nil;
	to = nil;
	xm = nil;
	va = nil;
	st = NONE;
	ac = me->rost;

	if(xmljacc(sock) < 0)
		return -1;
	if(loginjacc(sock, me->serv) < 0)
		return -1;

	x = openxmlpull(sock);
	while((b = nextxmlpull(x)) != nil && st != END){
		tmstmp = mktmstmp('(', ')');
		if(x->na != nil)
			x->na = filterzur(x->na);
		if(x->va != nil)
			x->va = filterzur(x->va);
		switch(b->ev){
		case START_DOCUMENT:
			if(me->debug)
				print("Start.\n");
			st = NONE;
			break;
		case START_TAG:
			if(me->debug)
				print("Tag: %s\n", x->na);
			if(!strcmp(x->na, "stream:stream")){
				st = STREAM;
				break;
			}
			if(!strcmp(x->na, "stream:error")){
				st = ERROR;
				break;
			}
			if(st == ERROR){
				if(strcmp(x->na, "text"))
					fprint(2, "%serror: %s\n", tmstmp, x->na);
				break;
			}
			if(!strcmp(x->na, "message")){
				st = MESSAGE;
				break;
			}
			if(!strcmp(x->na, "presence")){
				id = nil;
				st = PRESENCE;
				break;
			}
			if(!strcmp(x->na, "iq")){
				st = IQ;
				break;
			}
			if(!strcmp(x->na, "vCard") && st == IQ){
				st = IQ_VCARD;
				break;
			}
			if(!strcmp(x->na, "error") && st == IQ){
				st = IQ_ERROR;
				break;
			}
			if(!strcmp(x->na, "body") && st == MESSAGE){
				st = MESSAGE_INNER;
				break;
			}
			if(!strcmp(x->na, "html") && st == MESSAGE){
				st = MESSAGE_HTML;
				break;
			}
			if(!strcmp(x->na, "status") && (st == PRESENCE || st == PRESENCE_SET)){
				st = PRESENCE_STATUS;
				break;	
			}
			if(!strcmp(x->na, "show") && (st == PRESENCE || st == PRESENCE_SET)){
				st = PRESENCE_SHOW;
				break;
			}
			if(!strcmp(x->na, "error") && (st == PRESENCE || st == PRESENCE_SET)){
				st = PRESENCE_ERROR;
				break;
			}
			if(!strcmp(x->na, "x") && st == PRESENCE){
				st = PRESENCE_X;
				break;
			}
			if(!strcmp(x->na, "item") && st == ROSTER){
				if(me->rost == nil){
					me->rost = mkrostern();
					ac = mkrostern();
					me->rost->n = ac;
					me->rost->p = nil;
					me->rost->name = strdup(me->name);
					me->rost->jid = strdup(me->jid);
					me->rost->status = strdup(me->stat);
					me->rost->show = strdup(me->show);
					me->rost->subsc = strdup("self");
					me->rost->group = strdup("self");
				} else {
					ac->n = mkrostern();
					ac->n->p = ac;
					ac = ac->n;
					ac->n = nil;
				}
					
				st = ROSTER_INNER;
				break;
			}
			if(!strcmp(x->na, "query") && st == IQ){
				st = IQ_INNER;
				break;
			}
			if(!strcmp(x->na, "item") && st == IQ_INNER){
				st = IQ_ITEM;
				ac = mkrostern();
				break;
			}
			if(!strcmp(x->na, "group") && st == IQ_ITEM){
				st = IQ_GROUP;
				break;
			}
			if(!strcmp(x->na, "group") && st == ROSTER_INNER){
				st = ROSTER_GROUP;
				break;
			}
			if(!strcmp(x->na, "utc") && st == IQ_TIME){
				st = IQ_TIME_UTC;
				break;
			}
			if(!strcmp(x->na, "tz") && st == IQ_TIME){
				st = IQ_TIME_TZ;
				break;
			}
			if(!strcmp(x->na, "display") && st == IQ_TIME){
				st = IQ_TIME_DISPLAY;
				break;
			}
			if(!strcmp(x->na, "item") && st == IQ_DISCO){
				st = IQ_DISCO_ITEM;
				break;
			}
			if(!strcmp(x->na, "identity") && st == IQ_DISCO){
				print("%sserver identity:\n", tmstmp);
				st = IQ_DISCO_IDENT;
				break;
			}
			if(!strcmp(x->na, "feature") && st == IQ_DISCO){
				st = IQ_DISCO_FEATU;
				break;
			}
			if(!strcmp(x->na, "empty") && st == IQ_DISCO){
				st = IQ_DISCO_EMPTY;
				break;
			}
			if(!strcmp(x->na, "version") && st == IQ_VERSION){
				st = IQ_VERSION_VER;
				break;
			}
			if(!strcmp(x->na, "os") && st == IQ_VERSION){
				st = IQ_VERSION_OS;
				break;
			}
			if(!strcmp(x->na, "name") && st == IQ_VERSION){
				st = IQ_VERSION_NAME;
				break;
			}
			if(!strcmp(x->na, "agent") && st == IQ_AGENTS){
				st = IQ_AGENTS_AGENT;
				break;
			}
			if(!strcmp(x->na, "name") && st == IQ_AGENTS_AGENT){
				st = IQ_AGENTS_NAME;
				break;
			}
			if(!strcmp(x->na, "description") && st == IQ_AGENTS_AGENT){
				st = IQ_AGENTS_DESC;
				break;
			}
			if(!strcmp(x->na, "transport") && st == IQ_AGENTS_AGENT){
				print("%s  This is a transport.\n", tmstmp);
				break;
			}
			if(!strcmp(x->na, "groupchat") && st == IQ_AGENTS_AGENT){
				print("%s  You can groupchat here.\n", tmstmp);
				break;
			}
			if(!strcmp(x->na, "service") && st == IQ_AGENTS_AGENT){
				st = IQ_AGENTS_SERV;
				break;
			}
			if(!strcmp(x->na, "register") && st == IQ_AGENTS_AGENT){
				print("%s  You can register here.\n", tmstmp);
				break;
			}
			if(!strcmp(x->na, "search") && st == IQ_AGENTS_AGENT){
				print("%s  You can search here.\n", tmstmp);
				break;
			}
			if(st == IQ_VCARD){
				if(!strcmp(x->na, "FN"))
					goto is_vcard_inner;
				if(!strcmp(x->na, "GIVEN"))
					goto is_vcard_inner;
				if(!strcmp(x->na, "FAMILY"))
					goto is_vcard_inner;
				if(!strcmp(x->na, "MIDDLE"))
					goto is_vcard_inner;
				if(!strcmp(x->na, "PREFIX"))
					goto is_vcard_inner;
				if(!strcmp(x->na, "SUFFIX"))
					goto is_vcard_inner;
				if(!strcmp(x->na, "VERSION"))
					goto is_vcard_inner;
				if(!strcmp(x->na, "NICKNAME"))
					goto is_vcard_inner;
				if(!strcmp(x->na, "PHOTO"))
					goto is_vcard_inner;
				if(!strcmp(x->na, "BDAY"))
					goto is_vcard_inner;
				if(!strcmp(x->na, "POBOX"))
					goto is_vcard_inner;
				if(!strcmp(x->na, "EXTADR"))
					goto is_vcard_inner;
				if(!strcmp(x->na, "STREET"))
					goto is_vcard_inner;
				if(!strcmp(x->na, "LOCALITY"))
					goto is_vcard_inner;
				if(!strcmp(x->na, "REGION"))
					goto is_vcard_inner;
				if(!strcmp(x->na, "PCODE"))
					goto is_vcard_inner;
				if(!strcmp(x->na, "CTRY"))
					goto is_vcard_inner;
				if(!strcmp(x->na, "NUMBER"))
					goto is_vcard_inner;
				if(!strcmp(x->na, "USERID"))
					goto is_vcard_inner;
				if(!strcmp(x->na, "JABBERID"))
					goto is_vcard_inner;
				if(!strcmp(x->na, "MAILER"))
					goto is_vcard_inner;
				if(!strcmp(x->na, "LAT"))
					goto is_vcard_inner;
				if(!strcmp(x->na, "LON"))
					goto is_vcard_inner;
				if(!strcmp(x->na, "TITLE"))
					goto is_vcard_inner;
				if(!strcmp(x->na, "ROLE"))
					goto is_vcard_inner;
				if(!strcmp(x->na, "AGENT"))
					goto is_vcard_inner;
				if(!strcmp(x->na, "ORGNAME"))
					goto is_vcard_inner;
				if(!strcmp(x->na, "ORGUNIT"))
					goto is_vcard_inner;
				if(!strcmp(x->na, "NOTE"))
					goto is_vcard_inner;
				if(!strcmp(x->na, "PRODID"))
					goto is_vcard_inner;
				if(!strcmp(x->na, "REV"))
					goto is_vcard_inner;
				if(!strcmp(x->na, "PHONETIC"))
					goto is_vcard_inner;
				if(!strcmp(x->na, "DESC"))
					goto is_vcard_inner;
				if(!strcmp(x->na, "CRED"))
					goto is_vcard_inner;
				if(!strcmp(x->na, "HOME"))
					goto is_vcard_end;
				if(!strcmp(x->na, "WORK"))
					goto is_vcard_end;
				if(!strcmp(x->na, "POSTAL"))
					goto is_vcard_end;
				if(!strcmp(x->na, "PARCEL"))
					goto is_vcard_end;
				if(!strcmp(x->na, "DOM"))
					goto is_vcard_end;
				if(!strcmp(x->na, "INTL"))
					goto is_vcard_end;
				if(!strcmp(x->na, "PREF"))
					goto is_vcard_end;
				if(!strcmp(x->na, "VOICE"))
					goto is_vcard_end;
				if(!strcmp(x->na, "FAX"))
					goto is_vcard_end;
				if(!strcmp(x->na, "PAGER"))
					goto is_vcard_end;
				if(!strcmp(x->na, "MSG"))
					goto is_vcard_end;
				if(!strcmp(x->na, "CELL"))
					goto is_vcard_end;
				if(!strcmp(x->na, "VIDEO"))
					goto is_vcard_end;
				if(!strcmp(x->na, "BBS"))
					goto is_vcard_end;
				if(!strcmp(x->na, "MODEM"))
					goto is_vcard_end;
				if(!strcmp(x->na, "ISDN"))
					goto is_vcard_end;
				if(!strcmp(x->na, "PCS"))
					goto is_vcard_end;
				if(!strcmp(x->na, "INTERNET"))
					goto is_vcard_end;
				if(!strcmp(x->na, "X400"))
					goto is_vcard_end;
				break;
is_vcard_end:
				print("%s%s\n", tmstmp, x->na);
				break;
is_vcard_inner:
				print("%s%s = ", tmstmp, x->na);
				st = IQ_VCARD_INNER;
				break;
			}
			break;
		case START_END_TAG:
			if(me->debug)
				print("Startend: %s\n", x->na);
			if(!strcmp(x->na, "empty") && st == IQ_DISCO){
				print("%s <empty>\n", tmstmp);
				break;
			}
			if(!strcmp(x->na, "transport") && st == IQ_AGENTS_AGENT){
				print("%s  This is a transport.\n", tmstmp);
				break;
			}
			if(!strcmp(x->na, "groupchat") && st == IQ_AGENTS_AGENT){
				print("%s  You can groupchat here.\n", tmstmp);
				break;
			}
			if(!strcmp(x->na, "register") && st == IQ_AGENTS_AGENT){
				print("%s  You can register here.\n", tmstmp);
				break;
			}
			if(!strcmp(x->na, "search") && st == IQ_AGENTS_AGENT){
				print("%s  You can search here.\n", tmstmp);
				break;
			}
			if(st == ERROR || st == PRESENCE_ERROR || st == IQ_ERROR){
				fprint(2, "%serror: %s\n", tmstmp, x->na);
				break;
			}		
			break;
		case TEXT:
			if(me->debug)
				print("Text: %s\n", x->na);
			switch(st){
			case MESSAGE_INNER:
				type = strdup(x->na);
				break;
			case PRESENCE_SHOW:
				if(type == nil || (type != nil && strcmp(type, "error")))
					if(statusrostern(me->rost, from, from, nil, x->na) != nil)
						print("%s%s> %s\n", tmstmp, namerostern(me->rost, from, nil), x->na);
				break;
			case PRESENCE_STATUS:
				if(type == nil || (type != nil && strcmp(type, "error")))
					if(statusrostern(me->rost, from, from, x->na, nil) != nil)
						print("%s%s> %s\n", tmstmp, namerostern(me->rost, from, nil), x->na);
				break;
			case PRESENCE_ERROR:
				print("%s%s# %s\n", tmstmp, namerostern(me->rost, from, nil), x->na);
				free(type);
				type = strdup("isdone");
				break;
			case ROSTER_GROUP:
				if(ac->group == nil)
					ac->group = strdup(x->na);
				break;
			case IQ_GROUP:
				if(ac->group == nil)
					ac->group = strdup(x->na);
				break;
			case IQ_ERROR:
				print("%sIQ-Error: %s\n", tmstmp, x->na);
				break;
			case IQ_VCARD_INNER:
				print("%s\n", x->na);
				break;
			case IQ_VERSION_OS:
				print("%s  os = %s\n", tmstmp, x->na);
				break;
			case IQ_VERSION_NAME:
				print("%s  name = %s\n", tmstmp, x->na);
				break;
			case IQ_VERSION_VER:
				print("%s  version = %s\n", tmstmp, x->na);
				break;
			case IQ_TIME_UTC:
				print("%sutc = %s\n", tmstmp, x->na);
				break;
			case IQ_TIME_TZ:
				print("%stz = %s\n", tmstmp, x->na);
				break;
			case IQ_TIME_DISPLAY:
				print("%sdisplay = %s\n", tmstmp, x->na);
				break;
			case IQ_AGENTS_NAME:
				print("%s  name = %s\n", tmstmp, x->na);
				break;
			case IQ_AGENTS_DESC:
				print("%s  description = %s\n", tmstmp, x->na);
				break;
			case IQ_AGENTS_SERV:
				print("%s  service = %s\n", tmstmp, x->na);
				break;
			default:
				break;
			}
			break;
		case ATTR:
			if(me->debug)
				print("Attr: %s = %s\n", x->na, x->va);
			switch(st){
			case STREAM:
				if(!strcmp(x->na, "id")){
					st = NONE;
					if(me->reg){
						registerjacc(sock, me->serv, me->name, pass);
						break;
					}
					if(userjacc(sock, me->name, pass, me->reso) < 0) {
						memset(pass, 0, strlen(pass));
						st = AUTH;
						break;
					}
				}
				break;
			case MESSAGE:
				if(!strcmp(x->na, "from"))
					from = strdup(x->va);
				if(!strcmp(x->na, "to"))
					to = strdup(x->va);
				if(!strcmp(x->na, "type"))
					type = strdup(x->va);
				break;
			case PRESENCE:
				if(!strcmp(x->na, "from"))
					from = strdup(x->va);
				if(!strcmp(x->na, "type"))
					type = strdup(x->va);
				break;
			case IQ:
				if(!strcmp(x->na, "id")){
					if(!strcmp(x->va, "auth_1"))
						rosterjacc(sock);
					if(!strcmp(x->va, "auth_2"))
						st = ROSTER;
					if(!strcmp(x->va, "disco0"))
						st = IQ_DISCO;
					if(!strcmp(x->va, "time0"))
						st = IQ_TIME;
					if(!strcmp(x->va, "agents0"))
						st = IQ_AGENTS;
					if(!strcmp(x->va, "last0"))
						st = IQ_LAST;
					if(!strcmp(x->va, "version0"))
						st = IQ_VERSION;
					id = strdup(x->va);
				}
				if(!strcmp(x->na, "from"))
					from = strdup(x->va);
				if(!strcmp(x->na, "to"))
					to = strdup(x->va);
				if(!strcmp(x->na, "type"))
					type = strdup(x->va);
				break;
			case ROSTER_INNER:
				if(!strcmp(x->na, "name")){
					ac->name = strdup(x->va);
					break;
				}
				if(!strcmp(x->na, "jid")){
					ac->jid = strdup(x->va);
					break;
				}
				break;
			case IQ_INNER:
				if(!strcmp(x->na, "xmlns")){
					if(xm != nil)
						free(xm);
					xm = strdup(x->va);
				}
				if(!strcmp(x->na, "name")){
					if(va != nil)
						free(va);
					va = strdup(x->va);
				}
				break;
			case IQ_ITEM:
				if(!strcmp(x->na, "subscription")){
					ac->subsc = strdup(x->va);
					break;
				}
				if(!strcmp(x->na, "jid")){
					ac->jid = strdup(x->va);
					break;
				}
				if(!strcmp(x->na, "name")){
					ac->name = strdup(x->va);
					break;
				}
				break;
			case IQ_DISCO_IDENT:
				print("%s%s = %s\n", tmstmp, x->na, x->va);
				break;
			case IQ_DISCO_FEATU:
				print("%s  %s\n", tmstmp, x->va);
				break;
			case IQ_DISCO_ITEM:
				if(!strcmp(x->na, "name")){
					if(id != nil)
						free(id);
					id = strdup(x->va);
				}
				if(!strcmp(x->na, "jid")){
					if(to != nil)
						free(to);
					to = strdup(x->va);
				}
				break;
			case IQ_AGENTS_AGENT:
				if(!strcmp(x->na, "jid"))
					print("%s%s:\n", tmstmp, x->va);
				break;
			case IQ_LAST:
				if(!strcmp(x->na, "seconds"))
					print("%s%s> %ss away\n", tmstmp, namerostern(me->rost, nil, from), x->va);
				break;
			default:
				break;
			}
			break;
		case END_TAG:
			if(me->debug)
				print("Endtag: %s\n", x->na);
			if(!strcmp(x->na, "stream:stream")){
				st = END;
				break;
			}
			if(!strcmp(x->na, "stream:error") && st == ERROR){
				st = NONE;
				break;
			}
			if(st == ERROR)
				break;
			if(!strcmp(x->na, "message") && st == MESSAGE){
				if(type != nil) {
					print("%s(%s-%s)%% %s\n", tmstmp,
									(from != nil) ? namerostern(me->rost, from, nil) : "<nil>",
									(to != nil) ? namerostern(me->rost, to, nil) : "<nil>",
									type);
					playmp3("jacc_gotmessage.mp3");
				}
				if(from != nil)
					free(from);
				if(to != nil)
					free(to);
				if(type != nil)
					free(type);
				from = nil;
				to = nil;
				type = nil;
				st = NONE;
				break;
			}
			if(!strcmp(x->na, "presence") && st == PRESENCE_SET){
				if(type != nil)
					free(type);
				if(from != nil)
					free(from);
				type = nil;
				from = nil;
				st = NONE;
				break;
			}
			if(!strcmp(x->na, "presence") && st == PRESENCE){
				if(type != nil && from != nil){
					if(!strcmp(type, "unavailable") || !strcmp(type, "error")){
						if(statusrostern(me->rost, from, from, nil, "Offline") != nil)
							print("%s%s> Offline\n", tmstmp, namerostern(me->rost, from, nil));
						goto presence_strcmp;
					}
					if(!strcmp(type, "probe")){
						presencejacc(sock, me->stat, me->show, me->jid, from);
						goto presence_strcmp;
					}
					if(!strcmp(type, "subscribe")){
						statusrostern(me->rost, from, from, nil, "Online");
						print("%s%s wants to subscribe\n", tmstmp, namerostern(me->rost, from, nil));
						goto presence_strcmp;
					}
					if(!strcmp(type, "unsubscribe")){
						if(statusrostern(me->rost, from, from, nil, "Offline") != nil)
							print("%s%s wants to unsubscribe\n", tmstmp, namerostern(me->rost, from, nil));
						goto presence_strcmp;
					}
					if(!strcmp(type, "subscribed")){
						print("%s%s has accepted the subscription request\n", tmstmp, namerostern(me->rost, from, nil));
						goto presence_strcmp;
					}
					if(!strcmp(type, "isdone"))
						goto presence_strcmp;
				}
				if(from != nil) {
					statusrostern(me->rost, from, from, nil, "Online");
					print("%s%s> Online\n", tmstmp, namerostern(me->rost, from, nil));
				}
presence_strcmp:
				if(type != nil)
					free(type);
				if(from != nil)
					free(from);
				type = nil;
				from = nil;

				st = NONE;
				break;
			}
			if(!strcmp(x->na, "iq") && (st == IQ || st == IQ_DISCO)){
				if(from != nil)
					free(from);
				if(to != nil)
					free(to);
				if(type != nil)
					free(type);
				if(id != nil)
					free(id);
				if(va != nil)
					free(va);
				if(xm != nil)
					free(xm);
				from = nil;
				to = nil;
				id = nil;
				type = nil;
				va = nil;
				xm = nil;
				st = NONE;
				break;
			}
			if(!strcmp(x->na, "iq") && st == ROSTER){
				if(from != nil)
					free(from);
				if(to != nil)
					free(to);
				if(type != nil)
					free(type);
				if(id != nil)
					free(id);
				from = nil;
				to = nil;
				id = nil;
				type = nil;
				presencejacc(sock, me->stat, me->show, nil, nil);
				st = NONE;
				break;
			}
			if(!strcmp(x->na, "vCard") && st == IQ_VCARD){
				st = IQ;
				break;
			}
			if(!strcmp(x->na, "error") && st == IQ_ERROR){
				st = IQ;
				break;
			}
			if(!strcmp(x->na, "body") && st == MESSAGE_INNER){
				st = MESSAGE;
				break;
			}
			if(!strcmp(x->na, "html") && st == MESSAGE_HTML){
				st = MESSAGE;
				break;
			}
			if(!strcmp(x->na, "status") && st == PRESENCE_STATUS){
				st = PRESENCE_SET;
				break;
			}
			if(!strcmp(x->na, "show") && st == PRESENCE_SHOW){
				st = PRESENCE_SET;
				break;
			}
			if(!strcmp(x->na, "x") && st == PRESENCE_X){
				st = PRESENCE;
				break;
			}
			if(!strcmp(x->na, "error") && st == PRESENCE_ERROR){
				st = PRESENCE;
				break;
			}
			if(!strcmp(x->na, "item") && st == ROSTER_INNER){
				if(!doignore)
					print("%sAdded user: %s/%s/%s\n", tmstmp, ac->name, ac->jid, ac->group);
				st = ROSTER;
				break;
			}
			if(!strcmp(x->na, "query") && (st == IQ_INNER || st == IQ_VERSION || st == IQ_TIME || st == IQ_LAST || st == IQ_AGENTS)){
				if(st == IQ_INNER && xm != nil){
					if(!strcmp(xm, "jabber:iq:version")){
						if(strcmp(to, me->jid))
							break;
						else
							versionjacc(sock, me->jid, from, id);
						break;
					}
					if(!strcmp(xm, "jabber:iq:last"))
						if(!strcmp(me->jid, to))
							lastjacc(sock, to, from, id, time(0) - me->last);
					if(!strcmp(xm, "http://jabber.org/protocol/disco#info"))
						if(!strcmp(me->jid, to))
							if(id != nil && strcmp(id, "http://jabber.org/protocol/muc#rooms"))
								featuresjacc(sock, to, from, id);
					if(!strcmp(xm, "jabber:iq:time"))
						if(!strcmp(me->jid, to))
							timejacc(sock, to, from, id);
				}
				st = IQ;
				break;
			}
			if(!strcmp(x->na, "item") && st == IQ_ITEM){
				st = IQ_INNER;
				if(ac != nil && ac->subsc != nil){
					if(!strcmp(ac->subsc, "remove")){
						me->rost = delname(me->rost, ac->name, ac->jid);
						print("%sremoved: %s\n", tmstmp, ac->jid);
						freerostern(ac);
						break;
					}
					if(!strcmp(ac->subsc, "both") || !strcmp(ac->subsc, "to") ||
					   !strcmp(ac->subsc, "from") || !strcmp(ac->subsc, "none") ||
					   !strcmp(ac->subsc, "ask")){
						if(!strcmp(ac->subsc, "ask"))
							print("%s%s asks for authorisation.\n", tmstmp, ac->jid);
						if((p = searchrostern(me->rost, ac->name, ac->jid)) == nil){
							ac->subsc = strdup(ac->subsc);
							addrostern(me->rost, ac);
							if(strcmp(ac->subsc, "ask"))
								print("%sadded: %s\n", tmstmp, ac->jid);
						} else {
							if(p->jid != nil)
								free(p->jid);
							if(ac->jid != nil)
								p->jid = strdup(ac->jid);
							else
								p->jid = nil;

							if(p->name != nil)
								free(p->name);
							if(ac->name != nil)
								p->name = strdup(ac->name);
							else
								p->name = nil;

							if(p->subsc != nil)
								free(p->subsc);
							if(ac->subsc != nil)
								p->subsc = strdup(ac->subsc);
							else
								p->subsc = nil;

							print("%supdate: %s/%s\n", tmstmp, (ac->name == nil) ? "<nil>" : ac->name
										, (ac->jid == nil) ? "<nil>" : ac->jid);
							freerostern(ac);
						}
					}
				}
				ac = nil;
				break;
			}
			if(!strcmp(x->na, "group") && st == IQ_GROUP){
				st = IQ_ITEM;
				break;
			}
			if(!strcmp(x->na, "group") && st == ROSTER_GROUP){
				st = ROSTER_INNER;
				break;
			}
			if(!strcmp(x->na, "item") && st == IQ_DISCO_ITEM){
				print("%s  %s | %s\n", tmstmp, to, id);
				st = IQ_DISCO;
				break;
			}
			if(!strcmp(x->na, "identity") && st == IQ_DISCO_IDENT){
				print("%sfeatures:\n", tmstmp);
				st = IQ_DISCO;
				break;
			}
			if(!strcmp(x->na, "feature") && st == IQ_DISCO_FEATU){
				st = IQ_DISCO;
				break;
			}
			if(!strcmp(x->na, "empty") && st == IQ_DISCO_EMPTY){
				st = IQ_DISCO;
				break;
			}
			if(!strcmp(x->na, "utc") && st == IQ_TIME_UTC){
				st = IQ_TIME;
				break;
			}
			if(!strcmp(x->na, "tz") && st == IQ_TIME_TZ){
				st = IQ_TIME;
				break;
			}
			if(!strcmp(x->na, "display") && st == IQ_TIME_DISPLAY){
				st = IQ_TIME;
				break;
			}
			if(!strcmp(x->na, "version") && st == IQ_VERSION_VER){
				st = IQ_VERSION;
				break;
			}
			if(!strcmp(x->na, "name") && st == IQ_VERSION_NAME){
				st = IQ_VERSION;
				break;
			}
			if(!strcmp(x->na, "os") && st == IQ_VERSION_OS){
				st = IQ_VERSION;
				break;
			}
			if(!strcmp(x->na, "agent") && st == IQ_AGENTS_AGENT){
				st = IQ_AGENTS;
				print("%s\n", tmstmp);
				break;
			}
			if(!strcmp(x->na, "name") && st == IQ_AGENTS_NAME){
				st = IQ_AGENTS_AGENT;
				break;
			}
			if(!strcmp(x->na, "description") && st == IQ_AGENTS_DESC){
				st = IQ_AGENTS_AGENT;
				break;
			}
			if((!strcmp(x->na, "transport") || !strcmp(x->na, "groupchat")
					|| !strcmp(x->na, "register") || !strcmp(x->na, "search")) &&
					st == IQ_AGENTS_AGENT)
				break;
			if(!strcmp(x->na, "service") && st == IQ_AGENTS_SERV){
				st = IQ_AGENTS_AGENT;
				break;
			}
			if(st == IQ_VCARD_INNER){
				st = IQ_VCARD;
				break;
			}
			break;
		case END_DOCUMENT:
			if(me->debug)
				print("Documentend.\n");
			st = END;
			break;
		default:
			print("Please contact the xmlpull author about this. %x\n", b->ev);
			st = END;
			break;
		}
		free(tmstmp);
	}

	if(id != nil)
		free(id);
	freexmlpull(x);

	return 0;
}
