/*
 * Copy me if you can.
 * by 20h
 */

#include <u.h>
#include <libc.h>
#include "dat.h"
#include "roster.h"

void
freerostern(rostern *r)
{
	if(r != nil){
		if(r->name != nil)
			free(r->name);
		if(r->jid != nil)
			free(r->jid);
		if(r->status != nil)
			free(r->status);
		if(r->group != nil)
			free(r->group);
		if(r->show != nil)
			free(r->show);
		if(r->subsc != nil)
			free(r->subsc);
		free(r);
	}
	return;
}

void
freerosterl(rostern *r)
{
	rostern *b;

	if(r != nil){
		while(r->n != nil){
			b = r->n;
			freerostern(r);
			r = b;
		}
		freerostern(r);
	}

	return;
}

void
freejabberc(jabberc *j)
{

	if(j != nil){
		if(j->stat != nil)
			free(j->stat);
		if(j->name != nil)
			free(j->name);
		if(j->reso != nil)
			free(j->reso);
		if(j->serv != nil)
			free(j->serv);
		if(j->jid != nil)
			free(j->jid);
		if(j->rost != nil)
			freerosterl(j->rost);
		if(j->show != nil)
			free(j->show);
		free(j);
	}
	return;
}

rostern *
mkrostern(void)
{
	return reallocj(nil, sizeof(rostern), 2);
}

jabberc *
mkjabberc(void)
{
	return reallocj(nil, sizeof(jabberc), 2);
}

rostern *
delrostern(rostern *r)
{
	rostern *ret;
	
	ret = nil;

	//print("delrostern: %x r->n: %x r->p: %x\n", r, r->n, r->p);
	if(r->n != nil && r->p != nil){
		r->n->p = r->p;
		r->p->n = r->n;
		ret = r->p;
	} else {
		if(r->n != nil){
			r->n->p = nil;
			ret = r->n;
		} else {
			if(r->p != nil){
				r->p->n = nil;
				ret = r->p;
			}
		}
	}
	freerostern(r);

	return ret;
}

rostern *
lastrostern(rostern *r)
{
	while(r->n != nil)
		r = r->n;

	return r;
}

rostern *
addrostern(rostern *r, rostern *n)
{
	rostern *ret;

	//print("addrostern: %x %x %x\n", r, n, n->jid);
	ret = lastrostern(r);
	ret->n = n;
	n->p = ret;
	n->n = nil;

	return n;
}

rostern *
statusrostern(rostern *r, char *name, char *jid, char *status, char *show)
{
	r = searchrostern(r, name, jid);
	if(r != nil){
		if(show != nil){
			if(r->show != nil)
				if(!strcmp(r->show, show))
					return nil;
			if(r->show != nil)
				free(r->show);
			r->show = strdup(show);
		}
		if(status != nil){
			if(r->status != nil)
				if(!strcmp(r->status, status))
					return nil;
			if(r->status != nil)
				free(r->status);
			r->status = strdup(status);
		}
	}

	return r;
}

char *
namerostern(rostern *r, char *jid, char *name)
{

	r = searchrostern(r, name, jid);
	if(r != nil){
		if(jid != nil)
			if(r->name != nil)
				return r->name;
		if(name != nil)
			if(r->jid != nil)
				return r->jid;
	}

	if(jid != nil)
		return jid;
	return name;
}

rostern *
searchrostern(rostern *r, char *name, char *jid)
{

	//print("searchrostern: r: %x n: %x j: %x\n", r, name, jid);
	while(r != nil){
		if(name != nil && r->name != nil)
			if(!strcmp(name, r->name))
				return r;
		if(jid != nil && r->jid != nil)
			if(!strncmp(jid, r->jid, strlen(jid)) || !strncmp(jid, r->jid, strlen(r->jid)))
				return r;
		r = r->n;
	}

	return nil;
}

rostern *
delname(rostern *r, char *name, char *jid)
{
	rostern *ret;

	ret = searchrostern(r, name, jid);
	if(ret != nil){
		if(ret == r)
			return delrostern(ret);

		delrostern(ret);
	}

	return r;
}
